//
//  MeetingWindowDelegate.m
//  Rongcloud
//
//  Created by LiuLinhong on 2018/02/10.
//  Copyright © 2018年 Beijing Rongcloud Network Technology Co. , Ltd. All rights reserved.
//

#import "MeetingWindowDelegateImpl.h"
#import "MeetingViewController.h"

@interface MeetingWindowDelegateImpl ()

@property (nonatomic, strong) MeetingViewController *meetingViewController;

@end

@implementation MeetingWindowDelegateImpl

- (instancetype)initWithViewController:(NSViewController *)vc
{
    self = [super init];
    if (self)
    {
        self.meetingViewController = (MeetingViewController *) vc;
    }
    
    return self;
}

- (NSSize)windowWillResize:(NSWindow *)sender toSize:(NSSize)frameSize
{
    return NSMakeSize(840, 502);
}

- (void)windowDidResize:(NSNotification *)notification
{
    DLog(@"LLH...... Resize: %@", notification);
}

- (void)windowWillEnterFullScreen:(NSNotification *)notification
{
    DLog(@"LLH...... windowWillEnterFullScreen: %@", notification);
//    [self.meetingViewController transformToFullScreen];
}

- (void)windowDidEnterFullScreen:(NSNotification *)notification
{
    DLog(@"LLH...... windowDidEnterFullScreen: %@", notification);
    [self.meetingViewController transformToFullScreen];
}

- (void)windowWillExitFullScreen:(NSNotification *)notification
{
    DLog(@"LLH...... windowWillExitFullScreen: %@", notification);
}

- (void)windowDidExitFullScreen:(NSNotification *)notification
{
    DLog(@"LLH...... windowDidExitFullScreen: %@", notification);
    [self.meetingViewController transformToOriginalSize];
}

- (void)windowWillClose:(NSNotification *)notification
{
    //    [[NSNotificationCenter defaultCenter] postNotificationName:@"meetingWindowClosed" object:nil];
}

@end
