//
//  MeetingViewBuilder.h
//  Rongcloud
//
//  Created by LiuLinhong on 2017/08/14.
//  Copyright © 2017年 Beijing Rongcloud Network Technology Co. , Ltd. All rights reserved.
//

#import <AppKit/AppKit.h>
#import <Foundation/Foundation.h>
#import <WebKit/WebKit.h>
#import "BaseView.h"
#import "SwitchPageViewControl.h"

#define kVideoViewColor [NSColor colorWithRed:9.0/255.0 green:41.0/255.0 blue:64.0/255.0 alpha:0.6]
#define kThemeColor [NSColor colorWithRed:24.0/255.0 green:162.0/255.0 blue:234.0/255.0 alpha:1.0]

@interface MeetingViewBuilder : NSObject

//@property (nonatomic, strong) NSScrollView *scrollView;
@property (nonatomic, strong) BaseView *videosBottomView;
@property (nonatomic, strong) SwitchPageViewControl *switchPageViewControl;
//@property (nonatomic, strong) NSCollectionView *collectionView;
@property (nonatomic, strong) NSButton *leftScrollButton, *rightScrollButton, *downVideosBottomButton, *hungupButton;
@property (nonatomic, strong) NSButton *leftMessageButton, *rightMemberButton, *hideControlViewButton;
@property (nonatomic, strong) NSButton *exchangeVideoSizeButton, *dataInfoButton;
@property (nonatomic, strong) NSView *localVideoView, *leftMessageView, *rightMemberView;
//leftMessageView
@property (nonatomic, strong) NSView *controlContentView, *rightContentView;
@property (nonatomic, strong) NSCollectionView *controlCollectionView;
@property (nonatomic, strong) NSScrollView *controlScrollView, *tipMsgTextViewScrollView, *rightMVScrollView;
@property (nonatomic, strong) NSButton *leftMVVoiceButton, *leftMVSendButton;
@property (nonatomic, strong) NSTextField *meeageTextField, *screenShareMessageTextField, *durationTimeTextField;
@property (nonatomic, strong) NSTextView *tipMsgTextView;
//rightMemberView
@property (nonatomic, strong) NSTableView *rightTableView;
//signal
@property (nonatomic, strong) NSImageView *signalImageView, *callingBreathImageView, *callingHeadImageView, *mainAudioLevelImageView;
@property (nonatomic, strong) NSButton *callingAcceptButton, *callingHungUpButton;
//确认提示窗口
@property (nonatomic, strong) NSPanel *confirmMessagePanel, *alertMessagePanel;
@property (nonatomic, strong) WebView *whiteBoardWebView;
@property (nonatomic, strong) NSWindow *confirmMessageWindow, *alertMessageWindow;

@property (nonatomic, strong) NSPanel *avInfoPanel;
@property (nonatomic, strong) NSTableView *localDataTableView, *memberDataTableView;

- (instancetype)initWithViewController:(NSViewController *)vc;
- (void)reloadMeetingViewToFullScreen;
- (void)reloadMeetingViewToOriginalSize;
- (void)initVideoView;

@end
